/*  FILE    multi1.prg
* Author    Chuck Burfoot
* Created   Tue  01-22-1991
* Mod
*
* Purpose   Demo of preprocessor, nested reads, include files, and video
*           mode checking
*
*           Clipper multi1 /DLINCOLN   - Or translate per the rules of
*                                           multi1.ch and compile accordingly
*
*** */


*MULTI1.prg

#ifdef LINCOLN
    #include "MULTI1.CH"
#else
    #ifdef GERMAN
        #include "multi1.grm"
    #endif
    #ifdef JAPAN
        #include "multi1.j"
    #endif

    #ifdef SIESTA
        #include "multi1.sph"
    #endif
#endif

* A quick test for assurance that we don't forget to hit the /D whatever
* at compile time
*
* VERY SMART to set up an rmake file with this system

#ifndef MTEXT1_TEXT          && IF MTEXT1_TEXT is NOT defined (in a mem table)
    #include "nonesuch.ch"       /* During PHASE 1, if we've forgotten
                                   to specify a /D option, the non
                      existant file will force the compile to crash, and
                      when we go find out why, we'll remember when we see
                      this comment!! Saves going to the compiler and
           linker to find out we forgot to specify an option */
#endif

LOCAL vidmode
#define MONO_MODE  0       && Defines used with no need for translation
                            && Unless you intend to sell the source
#define CGA_MODE    1
#define EGA_MODE    2
#define VGA_MODE    3       && The substitution here isn't important
                            && Just as long as they are DISTINCTLY
                            && DIFFERENT. I use numbers because it's faster to
                            && do a compare.
SET DATE FORMAT (MDATE_FORMAT)     && See the include file


IF maxrow() = 24              && Test for video mode WITHOUT prompting
                              && user

           /*    WARNING, DESQVIEW environment doesn't
                 reset to 25 line mode if on EGA or VGA  */

    IF SETMODE( 50, 80)      && TRUE IF and ONLY if is VGA
        vidmode := VGA_MODE
        SETMODE(25, 80)
    ELSEIF SETMODE(43, 80)
        vidmode := EGA_MODE
        SETMODE(25, 80)      && CAME in as 25 line, leave out as 25
    ELSE                     && TRUE IF and ONLY if is EGA
        IF iscolor()
            vmode := CGA_MODE
        ELSE
            vidmode := MONO_MODE
        ENDIF
    ENDIF SETMODE( 50, 80)
ELSE
*
/* IF maxrow() > 24, MUST be a color monitor ( because of gray scale
  capability * I * consider the MVGA as quasi-color ) */

    IF maxrow() < 49           /* The only things between 49 and 24 line
                               mode that I'm sure is honored by SETMODE()
                               is the EGA with a MAXROW() of 42  */
        vidmode := EGA_MODE
    ELSE
        vidmode := VGA_MODE        /* As noted, MVGA included  */
    ENDIF

ENDIF  maxrow() = 24

IF vidmode = MONO_MODE
    SETCOLOR( "W+/B, GR+/N, , , w/n" )
ELSE
    SETCOLOR( "W+/B, GR+/N, , , w/n" )

    IF vidmode = CGA_MODE
        NOSNOW()              /* Bout time Nantucket gave us this
                                         flexabiltiy  */
    ENDIF
ENDIF

CLEAR SCREEN            && Set the colors

@ 0, 0 TO 24, MAXCOL()        /* Now we're sure that we have a 24 line
                                 mode. Box the ENTIRE screen regardless
                                  of 40 or 80 Column display.  */

@ 0, (MAXCOL() - LEN( MTEXT1_TEXT))/2 SAY MTEXT1_TEXT
@ 2, (MAXCOL() - LEN( MTEXT2_TEXT))/2 SAY MTEXT2_TEXT

SET MESSAGE TO 24 CENTER

iColtoprompt := IIF( maxcol() < 79, 10, 30 )  && Center placement regardless
                                              && of 40/80 mode

#define _DO_FOREVER_   DO WHILE .T.          && Don't like do while .t., OK.
                                             && Then how about do forever

_DO_FOREVER_                   && EXIT at IF ELSE ENDIF

   @ 5, iColtoprompt PROMPT PADC( MPROMPT_TEXT1, 20 ) ;  && Should be plenty wide
        MESSAGE MPROMPT_MSG1                          && enough
   @ 7, iColtoprompt PROMPT PADC( MPROMPT_TEXT2, 20 ) ;
        MESSAGE MPROMPT_MSG2                        && Fits up to 20 chars,
                                      && center text, at 10 in 40 col mode
                                      &&  at 20 in 80  col text
    MENU TO choice

    IF choice = 1
        PRETTY_WIN( vidmode )
    ELSE
        CLEAR SCREEN
        QUIT
    ENDIF
ENDDO FOREVER


*********************************
FUNC PRETTY_WIN( video )                  /* ONE LOCAL param, vid state  */
                  /* Note: no executable lines before local declares
                  but comments freely intermixed  */

LOCAL cScreen := SAVESCREEN( 10, MAXCOL()-35, 14, MAXCOL())
                  /* Save a screen portion on right set side, will work
                  in 40 or 80 column mode!  */

LOCAL cOcolor := SETCOLOR( IIF( video = MONO_MODE, "W+/N", "GR+/R"))
                   /* LOCAL's delcared and initialized on entry. STATIC's
                   can't be done this way. Static initialization must be
   SIMPLE ( a constant string or value ) or done later in line
   by an 'IF staticvar = NIL'  test  */

LOCAL lYn := .T.
LOCAL Getlist := {}     /* Getlist is unnecessary here, but I think
                              it adds clarity as we know that somewhere
                              below there's gonna be a READ  */

LOCAL iCursor := SETCURSOR( 1 )        /* or include setcur.ch  */

#include "BOX.CH"             /* #includes and defines can be anywhere
                                  inline as necessary  */

@ 10, MAXCOL()-35, 14, maxcol() BOX B_SINGLE_DOUBLE    /* Single sides
                                                        Double top and
                                                        bottom  */

SETCOLOR( IIF( video = MONO_MODE, "n/w", "b/w"))
                                    && NOTE that the define from waayyyy up
                                    && above works here.

scroll( 11, maxcol()-34, 13, maxcol() -1, 0 )      /* Clear the window  */

@ 12, MAXCOL()-33 SAY MWIN1_TEXT GET lYn PICTURE "@! Y" VALID respond( lYn )

           /* Note that the lYn passed into the validation routine
           was NOT passed by reference with the '@' sign prefixed. We won't
           change the contents they will just be used in that routine
           to reply to the user.  */

READ       /* NOTE, nested read without a read save. READ SAVE allows for
            ADDITIVE gets, re-entering from the 1ST of the set each time
            the read save is issued, and is not required for NESTING  */

 /* Could have responded to user's answer here. But more fun and shows an
 example of a nested read to do it this way.  */
SETCURSOR( iCursor )
SETCOLOR( cOcolor )
RESTSCREEN( 10, MAXCOL() - 35, 14, MAXCOL(), cScreen)

RETURN NIL


*****************************************
FUNC RESPOND( lDidlike )
LOCAL GETLIST := {}               /* THIS one IS required, else the
                                    GETLIST could become additive IF
                                    there were a prior get (without a
                                    clear gets ) or had NOT be declared
                                    as a LOCAL - state what you mean

       AND DO NOT  - DOO NNNOOOOOTTTTTT   ASS U ME  */
LOCAL cScreen := SAVESCREEN( 14, maxcol()-39, 18, maxcol()-5 )
LOCAL cOcolor := SETCOLOR( "N/W" )
LOCAL iCursor := SETCURSOR( 1 )
LOCAL lYn := .T.

@ 14, maxcol()-39 TO 18, maxcol()-5 DOUBLE
scroll( 15, maxcol()-38, 17, maxcol()-6, 0 )     /* Some like  15, 6 CLEAR TO 17, 34  */

@ 16, maxcol()-37 SAY IIF( lDidlike, MWIN2_TRUE, MWIN2_FALSE )
inkey(1)        /* One second apology!  */

IF !lDidlike           /* IF they didn't like it, give them a chance to
                               change it.  */

   @ 16, maxcol()-37 SAY MWIN2_TEXT GET lYn PICTURE "@! Y"
   READ

   IF lYn      /* IF they want to change it,
                    inform them that they're stuck  */

      scroll( 15, maxcol()-38, 17, maxcol()-6, 0 )
      @ 16, maxcol()-37 SAY MWIN2_FALSE
      inkey(1)
   ENDIF
ENDIF
SETCURSOR( iCursor )
SETCOLOR( cOcolor )
RESTSCREEN( 14, maxcol()-39, 18, maxcol()-5, cScreen )

#define TRUE  .T.
                          /* Defines can occur anywhere, but
will ONLY BE VISIBLE from the POINT of definition to EITHER the end of file
or a #UNDEF, whichever comes first  */

RETURN TRUE

#undef TRUE                /* No longer visible, ie TRUE no longer EXISTS
                           as far as the preprocessor is concerned and
                           no longer refers to .T. */

/*--<EOF  multi1.prg >--*/
